{
    "inputs": [
        {
            "type": [
                {
                    "items": [
                        "null",
                        "File"
                    ],
                    "type": "array"
                }
            ],
            "id": "#main/theCalls"
        }
    ],
    "requirements": [
        {
            "class": "InlineJavascriptRequirement"
        }
    ],
    "doc": "VDJ_GatherCalls collect the outputs from the multi-processed VDJ step into one file.\n",
    "id": "#main",
    "steps": [
        {
            "out": [
                "#main/VDJ_GatherCalls/gatheredCalls"
            ],
            "run": {
                "cwlVersion": "v1.0",
                "inputs": [
                    {
                        "type": [
                            {
                                "items": [
                                    "null",
                                    "File"
                                ],
                                "type": "array"
                            }
                        ],
                        "id": "#main/VDJ_GatherCalls/gather_PyIR/theCalls"
                    }
                ],
                "requirements": [
                    {
                        "dockerPull": "docker.io/bdgenomics/rhapsody:1.11",
                        "class": "DockerRequirement"
                    },
                    {
                        "class": "InlineJavascriptRequirement"
                    },
                    {
                        "class": "ShellCommandRequirement"
                    }
                ],
                "outputs": [
                    {
                        "outputBinding": {
                            "glob": "*_constant_region_called_pruned.csv.gz",
                            "outputEval": "${\n  if (self.size == 0) {\n    throw(\"No outputs from PyIR detected in VDJ_GatherCalls!\");\n  } else {\n    return(self);\n  }\n}"
                        },
                        "type": [
                            "null",
                            "File"
                        ],
                        "id": "#main/VDJ_GatherCalls/gather_PyIR/gatheredCalls"
                    }
                ],
                "class": "CommandLineTool",
                "arguments": [
                    {
                        "shellQuote": false,
                        "valueFrom": "${\n  if (!inputs.theCalls[0] ) {\n    return (\"echo \\\"No outputs from PyIR detected in VDJ_GatherCalls\\\"\")\n  }\n  var inputFiles = \"\"\n  if (!inputs.theCalls[0].path.split(\"_PrunePyIR\")[1]){\n    inputFiles = \"zcat\"\n    for (var i = 0; i < inputs.theCalls.length; i++) {\n      inputFiles += \" \" + inputs.theCalls[i].path\n    }\n    inputFiles += \" | \"\n  } else {\n    inputFiles = \"zcat \" + inputs.theCalls[0].path.split(\"VDJ\")[0] + \"*\" + inputs.theCalls[0].path.split(\"_PrunePyIR\")[1].split(\"_Number_\")[0] + \"_Number_*.csv.gz | \"\n  }\n  var outputFileName = \"\\\"gzip > \" + inputs.theCalls[0].nameroot.split(\"_Number_\")[0] + \"_constant_region_called_pruned.csv.gz\" + \"\\\"\"\n  var awkCommand =  \"awk \\'NR==1{F=$1;print | \" + outputFileName + \" } $1!=F { print | \" + outputFileName + \" }\\' \"\n  var outputCommand = inputFiles + awkCommand\n  return (outputCommand)\n}"
                    }
                ],
                "id": "#main/VDJ_GatherCalls/gather_PyIR"
            },
            "id": "#main/VDJ_GatherCalls",
            "in": [
                {
                    "source": "#main/theCalls",
                    "id": "#main/VDJ_GatherCalls/theCalls"
                }
            ]
        }
    ],
    "class": "Workflow",
    "outputs": [
        {
            "outputSource": "#main/VDJ_GatherCalls/gatheredCalls",
            "type": [
                "null",
                "File"
            ],
            "id": "#main/gatheredCalls"
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "sbg": "https://sevenbridges.com#",
        "arv": "http://arvados.org/cwl#"
    }
}
